/********************************************





********************************************/

#include "common.ch"

#include "FRACTAL.CH"

PROCEDURE Fractal(nPOINTS)
LOCAL aEdges, TmpEdge, OldPoint, k, n
LOCAL nEDGE

DEFAULT nPOINTS TO NUM_POINTS

*  nEDGE  := RandomInt(NUM_EDGE,10*NUM_EDGE)
   nEDGE  := NUM_EDGE

   // Drei Punkte im CRT Fenster bilden ein Dreieck
   aEdges := Array( nEDGE )
   AEval( aEdges, { |e| e:=RandPoint() }, , , .T. )

   // Den Startpunkt setzen
   OldPoint := RandPoint()
   GraLine( , OldPoint, OldPoint )
   FOR n := 1 to nPOINTS
      // Die Farbe setzen
      GraSetColor(, RandColor())

      // Zufllig einen Punkt des Dreiecks auswhlen
      TmpEdge  := aEdges[RandomInt(nEDGE)]
      // Der neue Punkt liegt auf der Hlfte der Strecke
      // des Start Punktes und einer Dreiecks Ecke
      OldPoint[1] := (TmpEdge[1]+OldPoint[1])/2
      OldPoint[2] := (TmpEdge[2]+OldPoint[2])/2
      // Punkt zeichnen
      GraLine(, OldPoint, OldPoint)
   NEXT

RETURN

//
// Fraktal zeichnen
//

// Berechnen eines zuflligen Punktes

STATIC FUNCTION RandPoint()
   STATIC aSize := NIL
   IF aSize == NIL
      aSize := SetAppWindow():currentSize()
   ENDIF
RETURN {RandomInt(0,aSize[1]),RandomInt(0,aSize[2])}

// Berechnen einer Farbe mit zuflligen RGB Anteilen
STATIC FUNCTION RandColor()
   LOCAL nColor
   nColor := GraMakeRGBColor( { RandomInt(0,255), ;
                                RandomInt(0,255), ;
                                RandomInt(0,255)})

RETURN nColor

*
*
*